------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Actions;
with Qt4.Child_Events;
with Qt4.Events;
with Qt4.Layouts;
with Qt4.Timer_Events;
with Qt4.Widgets;
with Qt_Ada.Internals.Events;
with Qt_Ada.Internals.Object_Registry;
pragma Elaborate (Qt_Ada.Internals.Object_Registry);
with Qt_Ada.Internals.Objects;
with Qt_Ada.Internals.Objects.Object_Utilities;
with Qt_Ada.Internals.Objects.Widget_Utilities;

package body Qt4.Ui_Loaders.Directors is

   function qt_metacall_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Kind : Qt4.Meta_Objects.Call;
     Id   : Qt4.Q_Integer;
     Args : Qt4.Address_Pointer)
       return Qt4.Q_Integer;
   pragma Import (C, qt_metacall_wrapper,
                  "__Qt4Ada_QUiLoader_qt_metacall_wrapper");

   function qt_metacast_wrapper
    (Self  : not null access Qt_Ada.Internals.Objects.QObject;
     Class : Interfaces.C.char_array)
       return System.Address;
   pragma Import (C, qt_metacast_wrapper,
                  "__Qt4Ada_QUiLoader_qt_metacast_wrapper");

   function createAction_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Parent : access Qt_Ada.Internals.Objects.QObject;
     Name : not null access Qt4.Strings.Internals.QString)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Export (C, createAction_0_dispatch,
                     "__Qt4Ada_QUiLoader_createAction_0_dispatch");
   pragma Warnings (Off, createAction_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   function createAction_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Parent : access Qt_Ada.Internals.Objects.QObject;
     Name : not null access constant Qt4.Strings.Internals.QString)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, createAction_0_wrapper,
                     "__Qt4Ada_QUiLoader_createAction_0_wrapper");

   function createLayout_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Class_Name : not null access Qt4.Strings.Internals.QString;
     Parent : access Qt_Ada.Internals.Objects.QObject;
     Name : not null access Qt4.Strings.Internals.QString)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Export (C, createLayout_0_dispatch,
                     "__Qt4Ada_QUiLoader_createLayout_0_dispatch");
   pragma Warnings (Off, createLayout_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   function createLayout_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Class_Name : not null access constant Qt4.Strings.Internals.QString;
     Parent : access Qt_Ada.Internals.Objects.QObject;
     Name : not null access constant Qt4.Strings.Internals.QString)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, createLayout_0_wrapper,
                     "__Qt4Ada_QUiLoader_createLayout_0_wrapper");

   function createWidget_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Class_Name : not null access Qt4.Strings.Internals.QString;
     Parent : access Qt_Ada.Internals.Objects.QObject;
     Name : not null access Qt4.Strings.Internals.QString)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Export (C, createWidget_0_dispatch,
                     "__Qt4Ada_QUiLoader_createWidget_0_dispatch");
   pragma Warnings (Off, createWidget_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   function createWidget_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Class_Name : not null access constant Qt4.Strings.Internals.QString;
     Parent : access Qt_Ada.Internals.Objects.QObject;
     Name : not null access constant Qt4.Strings.Internals.QString)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, createWidget_0_wrapper,
                     "__Qt4Ada_QUiLoader_createWidget_0_wrapper");

   procedure childEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, childEvent_0_wrapper,
                     "__Qt4Ada_QUiLoader_childEvent_0_wrapper");

   procedure customEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, customEvent_0_wrapper,
                     "__Qt4Ada_QUiLoader_customEvent_0_wrapper");

   procedure timerEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, timerEvent_0_wrapper,
                     "__Qt4Ada_QUiLoader_timerEvent_0_wrapper");

   function sender_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, sender_0_wrapper,
                     "__Qt4Ada_QUiLoader_sender_0_wrapper");

   pragma Style_Checks ("N");

   -----------------------------
   -- createAction_0_dispatch --
   -----------------------------

   function createAction_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Parent : access Qt_Ada.Internals.Objects.QObject;
     Name : not null access Qt4.Strings.Internals.QString)
       return not null access Qt_Ada.Internals.Objects.QObject
   is
   begin
      return
        Q_Ui_Loader_Director'Class (Self.all).Create_Action
         (Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_Q_Object (Parent),
          Qt4.Strings.Internals.Create_Wrapper (Qt4.Strings.Internals.QString_Access (Name))).QObject_View;
   end createAction_0_dispatch;

   -------------------
   -- Create_Action --
   -------------------

   overriding
   function Create_Action
    (Self : not null access Q_Ui_Loader_Director;
     Parent : access Qt4.Objects.Q_Object'Class;
     Name : Qt4.Strings.Q_String
       := Qt4.Strings.Create)
       return not null access Qt4.Actions.Q_Action'Class
   is
   begin
      return
        Qt4.Actions.Q_Action'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (createAction_0_wrapper
             (Q_Ui_Loader_Director'Class (Self.all).QObject_View,
              Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject (Parent),
              Qt4.Strings.Internals.QString_View (Name))).all)'Access;
   end Create_Action;

   -----------------------------
   -- createLayout_0_dispatch --
   -----------------------------

   function createLayout_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Class_Name : not null access Qt4.Strings.Internals.QString;
     Parent : access Qt_Ada.Internals.Objects.QObject;
     Name : not null access Qt4.Strings.Internals.QString)
       return not null access Qt_Ada.Internals.Objects.QObject
   is
   begin
      return
        Q_Ui_Loader_Director'Class (Self.all).Create_Layout
         (Qt4.Strings.Internals.Create_Wrapper (Qt4.Strings.Internals.QString_Access (Class_Name)),
          Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_Q_Object (Parent),
          Qt4.Strings.Internals.Create_Wrapper (Qt4.Strings.Internals.QString_Access (Name))).QObject_View;
   end createLayout_0_dispatch;

   -------------------
   -- Create_Layout --
   -------------------

   overriding
   function Create_Layout
    (Self : not null access Q_Ui_Loader_Director;
     Class_Name : Qt4.Strings.Q_String;
     Parent : access Qt4.Objects.Q_Object'Class;
     Name : Qt4.Strings.Q_String
       := Qt4.Strings.Create)
       return not null access Qt4.Layouts.Q_Layout'Class
   is
   begin
      return
        Qt4.Layouts.Q_Layout'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (createLayout_0_wrapper
             (Q_Ui_Loader_Director'Class (Self.all).QObject_View,
              Qt4.Strings.Internals.QString_View (Class_Name),
              Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject (Parent),
              Qt4.Strings.Internals.QString_View (Name))).all)'Access;
   end Create_Layout;

   -----------------------------
   -- createWidget_0_dispatch --
   -----------------------------

   function createWidget_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Class_Name : not null access Qt4.Strings.Internals.QString;
     Parent : access Qt_Ada.Internals.Objects.QObject;
     Name : not null access Qt4.Strings.Internals.QString)
       return not null access Qt_Ada.Internals.Objects.QObject
   is
   begin
      return
        Q_Ui_Loader_Director'Class (Self.all).Create_Widget
         (Qt4.Strings.Internals.Create_Wrapper (Qt4.Strings.Internals.QString_Access (Class_Name)),
          Qt_Ada.Internals.Objects.Widget_Utilities.Corresponding_Q_Widget (Parent),
          Qt4.Strings.Internals.Create_Wrapper (Qt4.Strings.Internals.QString_Access (Name))).QObject_View;
   end createWidget_0_dispatch;

   -------------------
   -- Create_Widget --
   -------------------

   overriding
   function Create_Widget
    (Self : not null access Q_Ui_Loader_Director;
     Class_Name : Qt4.Strings.Q_String;
     Parent : access Qt4.Widgets.Q_Widget'Class;
     Name : Qt4.Strings.Q_String
       := Qt4.Strings.Create)
       return not null access Qt4.Widgets.Q_Widget'Class
   is
   begin
      return
        Qt4.Widgets.Q_Widget'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (createWidget_0_wrapper
             (Q_Ui_Loader_Director'Class (Self.all).QObject_View,
              Qt4.Strings.Internals.QString_View (Class_Name),
              Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject (Parent),
              Qt4.Strings.Internals.QString_View (Name))).all)'Access;
   end Create_Widget;

   -----------------
   -- Child_Event --
   -----------------

   overriding
   procedure Child_Event
    (Self : not null access Q_Ui_Loader_Director;
     Event : not null access Qt4.Child_Events.Q_Child_Event'Class)
   is
   begin
      childEvent_0_wrapper
       (Q_Ui_Loader_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Child_Event;

   ------------------
   -- Custom_Event --
   ------------------

   overriding
   procedure Custom_Event
    (Self : not null access Q_Ui_Loader_Director;
     Event : not null access Qt4.Events.Q_Event'Class)
   is
   begin
      customEvent_0_wrapper
       (Q_Ui_Loader_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Custom_Event;

   -----------------
   -- Timer_Event --
   -----------------

   overriding
   procedure Timer_Event
    (Self : not null access Q_Ui_Loader_Director;
     Event : not null access Qt4.Timer_Events.Q_Timer_Event'Class)
   is
   begin
      timerEvent_0_wrapper
       (Q_Ui_Loader_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Timer_Event;

   ------------
   -- Sender --
   ------------

   overriding
   function Sender
    (Self : not null access constant Q_Ui_Loader_Director)
       return access Qt4.Objects.Q_Object'Class
   is
   begin
      return
        Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_Q_Object
         (sender_0_wrapper
           (Q_Ui_Loader_Director'Class (Self.all).QObject_View));
   end Sender;

begin
   Qt_Ada.Internals.Object_Registry.Register_Director
    ("QUiLoader", qt_metacast_wrapper'Access, qt_metacall_wrapper'Access);

end Qt4.Ui_Loaders.Directors;
